module RCM
  class Package
    attr_accessor :name, :version, :state

    # Public state constants
    INSTALLED = 'installed'.freeze
    REMOVED = 'removed'.freeze
    CHANGED = 'changed'.freeze

    def ==(other)
      return false unless other.is_a?(RCM::Package)

      @name == other.name &&
      @version == other.version &&
      @state == other.state
    end

    def initialize(name, version, state)
      @name = name
      @version = version
      @state = state
    end

    def to_s
      "Name = #{@name}\n" +
      "Version = #{@version}\n" +
      "State = #{@state}\n"
    end
  end
end
